<?php
/**
 * @name avaibility
 * @description construction du block avaibility dans les rapports
 *		Tous les blocs avaibility passent par ce code pour construire le graph, donut,...
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

if(empty($_SERVER['DOCUMENT_ROOT'])) 
{
	$is_cli=true;
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once $path.'/plugin/report/Model_Report.php';
if(!$is_cli)
{
	include_once '/usr/local/esia/public_html/common.php';
}

$SHORT_OPTS="a:i:s:e:l:";
$LONG_OPTS=array("action:","id:","start:","end:","language:");
if((isset($_POST['blockid']))&&!empty($_POST['blockid'])) // Lors de la modification du bloc
{
	$idInclude= $_POST['blockid'];
	$action= $_GET['action'];	
}
elseif((isset($_GET['id'])) &&!empty($_GET['id'])) // Lors de l'ajout du bloc
{
	$idInclude=$_GET['id'];
	$action=$_GET['action'];
}
else // Lors de l'appel par repor_generate.php
{
	$options = getopt($SHORT_OPTS, $LONG_OPTS);
	
	$action	  = getParam($options,"action","a");
	$idInclude= getParam($options,"id","i");
	$start	  = getParam($options,"start","s");
	$end	  = getParam($options,"end","e");
	$language = getParam($options,"language","l");

	include_once $path.'/plugin/report/lang/'.$language.'.php';
	include_once $path.'/lang/'.$language.'/common_plugin_name.php';
	
	$datetime1 = new DateTime($start);
	$datetime2 = new DateTime($end);
	$diff = $datetime1->diff($datetime2);
	$interval = $diff ->format('%a');

	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
}
$query=Model_Report::getReportIncludeBlock($dbconnection,$idInclude);
$query= $query[0];

if($action=="generate")
{	
	$param = json_decode($query['include_parameter'],true);
	//$param['onegraph']=false;
	echo '<div class="clear"></div>';
	//echo'<section class="blockTier">
	echo '<section class="blockView">
       		<div class="blockView_title">
	       		<h3 style="text-align:'.$param['title']['style']['text-align'].';
						font-size:'.$param['title']['style']['font-size'].';
						color:'.$param['title']['style']['color'].'"
						><p>'.$param['title']['text'].'</p></h3>
        	</div>
	       	<div class="pad">
        		<p style="text-align:'.$param['description']['style']['text-align'].';
						font-size:'.$param['description']['style']['font-size'].'"
							>'.$param['description']['text'].'</p>';

	if($param['type']=="service")
	{			
		if($param['forme']=="donut")
		{
			if($param['onegraph']==true)
			{
				createHtmlItem($param,'donut');
			}
			else
			{
				foreach ($param['nodeid'] as $node)
				{			
					$listservice = Model_esia::getServices($dbconnection,$node);
					foreach ($param['serviceid'] as $idService)
					{
						$name=SearchIfContainService($listservice,$idService);			
						if($name!=false)
						{
							$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
							$resultat=Model_esia::getTimeErrorAvailability($dbconnection,$node,$idService,$end,$interval);
							$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
							echo '<table class="tab"><thead><tr valign="top"><th><p>'.$name['device_name'].' : '.$CommonName.'</p></th></tr></thead><tbody><tr><td>';
							CreationDonutHtml($idService,$resultat,$lang);										
						}
					}				
				}
			}
		}
		elseif($param['forme']=="tab2")
		{
		    
			$elementTab = array();
			$temp= array();
			foreach ($param['nodeid'] as $node) 
			{				
			    try  
			    {
    				$infonode=Model_esia::InstanceNode($dbconnection,$node);				
    				$listservice = Model_esia::getServices($dbconnection,$node);
    				foreach ($param['serviceid'] as $idService)
    				{
    					$name=SearchIfContainService($listservice,$idService);
    					if($name!=false)
    					{				
    						$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
    						$resultat=Model_esia::getTimeErrorAvailability($dbconnection,$node,$idService,$end,$interval);		
    						$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
    						$elementTab[] = array('groupname'=>$infonode->getGroup(),'ip'=>$infonode->getIPAddress(),'device_type'=>$name['device_type'],'device_name'=>$name['device_name'],'CommonName'=>$CommonName,'percent'=>$resultat['ok']['percent']);
    					}
    				}
			    }
			    catch(Exception $e)
			    {
			        
			    }
			}			
			echo '<table class="tab"><thead><tr valign="top"><th><p>'.$lang['REPORT_AVAILABILITY_GROUPES'].'</p></th><th><p>'.$lang['REPORT_AVAILABILITY_NODES'].'</p></th><th><p>'.$lang['REPORT_AVAILABILITY_SERVICES'].'</p></th>';
			if($param['affiche_type']==true)
			{
				echo '<th><p>'.$lang['REPORT_NODE_TYPE'].'</p></th>';
			}
			if($param['affiche_ip']==true)
			{
				echo '<th><p>'.$lang['REPORT_IP_ADD'].'</p></th>';
			}
			echo '<th><p>'.$lang['REPORT_AVAILABILITY_DISPO'].'</p></th></tr></thead><tbody>';
			CreationTabHtml($elementTab,$param,"service");
		}
		elseif($param['forme']=="graph")
		{
			if($param['onegraph']==true)
			{
				$listname = array();
				$val = array();
				foreach ($param['nodeid'] as $node)
				{
					$listservice = Model_esia::getServices($dbconnection,$node);
					foreach ($param['serviceid'] as $idService)
					{
						$name=SearchIfContainService($listservice,$idService);
						if($name!=false)
						{
							$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
							$pourcent = getAvailabilityList($dbconnection,$node,$idService,$end,$interval);
							foreach ($pourcent as $key => $valpourcent)
							{
								$val[$key] = $val[$key]+$valpourcent;
							}
																		
							
							array_push($listname , $name['device_name']." : ".$CommonName);
							$i = $i + $idService;
						}
					}
				}
				echo '<table class="tab"><thead><tr valign="top"><th><p>'.(implode(" & ",$listname)).'</p></th></tr></thead><tbody><tr><td>';
				$parsed = array();
				foreach ($val as $key => $valpourcent)
				{
					$parsed[parseAvailabilityDate($key,$interval)] = ($val[key]+$valpourcent)/count($param['serviceid']);
				}
				CreationGraphServiceHtml($parsed,$i,$lang,$interval);
			}
			else
			{
				foreach ($param['nodeid'] as $node)
				{
					$listservice = Model_esia::getServices($dbconnection,$node);
					foreach ($param['serviceid'] as $idService)
					{
						$name=SearchIfContainService($listservice,$idService);
						if($name!=false)
						{
							$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
							$pourcent = getAvailabilityList($dbconnection,$node,$idService,$end,$interval);
							if($pourcent!=null)
							{
								$parsed = array();
								foreach ($pourcent as $key => $valpourcent)
								{
									$parsed[parseAvailabilityDate($key,$interval)] = $valpourcent;
								}
								
								echo '<table class="tab"><thead><tr valign="top"><th><p>'.$name['device_name'].' : '.$CommonName.'</p></th></tr></thead><tbody><tr><td>';
								CreationGraphServiceHtml($parsed,$idService,$lang,$interval);
							}
						}
					}
				}
			}
		}
		elseif ($param['forme']=="abre")
		{	
			if($param['onegraph']==true)
			{
				createHtmlItem($param,'abreviation');
			}
			else
			{		
				foreach ($param['nodeid'] as $node) 
				{
					$listservice = Model_esia::getServices($dbconnection,$node);
					foreach ($param['serviceid'] as $idService)
					{
						$name=SearchIfContainService($listservice,$idService);
						if($name!=false)
						{
							$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
							$resultat=Model_esia::getTimeErrorAvailability($dbconnection,$node,$idService,$end,$interval);
							$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
							$state= returnState($resultat['ok']['percent'],$param);						
							echo '<table class="tab"><thead><tr valign="top"><th><p>'.$name['device_name'].' : '.$CommonName.'</p></th></tr></thead><tbody><tr><td>';
							CreationAbreviationHtml($lang,$state);
						}
					}
				}
			}
		}
		elseif($param['forme']=="token" || $param['forme']=="rectangle")
		{
			if ($param['forme']=="token")
			{
				$radius="50%";
			}
			else
			{
				$radius="5px";
			}
			
			if($param['onegraph']==true)
			{
				createHtmlItem($param,$param['forme']);
			}
			else
			{
				foreach ($param['nodeid'] as $node)
				{
					$listservice = Model_esia::getServices($dbconnection,$node);
					foreach ($param['serviceid'] as $idService)
					{
						$name=SearchIfContainService($listservice,$idService);
						if($name!=false)
						{
							$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
							$resultat=Model_esia::getTimeErrorAvailability($dbconnection,$node,$idService,$end,$interval);
							$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
							$state=returnState($resultat['ok']['percent'],$param);
							echo '<table class="tab"><thead><tr valign="top"><th><p>'.$name['device_name'].' : '.$CommonName.'</p></th></tr></thead><tbody><tr><td>';
							CreationTokenOrRectangleHtml($state,$radius);	
						}
					}
				}
			}
		}
		elseif($param['forme']=="gauge")
		{
			if($param['onegraph']==true)
			{
				createHtmlItem($param,'gauge');
			}
			else
			{
				foreach ($param['nodeid'] as $node)
				{			
					$listservice = Model_esia::getServices($dbconnection,$node);				
					foreach ($param['serviceid'] as $idService)
					{
						$name=SearchIfContainService($listservice,$idService);
						if($name!=false)
						{
							$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
							$resultat=Model_esia::getTimeErrorAvailability($dbconnection,$node,$idService,$end,$interval);		
							$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
							echo '<table class="tab"><thead><tr valign="top"><th><p>'.$name['device_name'].' : '.$CommonName.'</p></th></tr></thead><tbody><tr><td>';
							CreationGaugeHtml($idService,$resultat,$lang);
						}
					}				
				}
			}
		}
		elseif($param['forme']=='graphCol')
		{
		    $elementTab = array();
		    foreach ($param['nodeid'] as $node)
		    {
		        try
		        {
		            $infonode=Model_esia::InstanceNode($dbconnection,$node);
		            $listservice = Model_esia::getServices($dbconnection,$node);
		            foreach ($param['serviceid'] as $idService)
		            {
		                $name=SearchIfContainService($listservice,$idService);
		                if($name!=false)
		                {
		                    $CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
		                    $resultat=Model_esia::getTimeErrorAvailability($dbconnection,$node,$idService,$end,$interval);
		                    $resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
		                    $elementTab[$infonode->getName().' - '.$name['service_name'].$idService] = array('name'=>$infonode->getName()."-".$CommonName,'percent'=>$resultat['ok']['percent']);
		                }
		            }
		        }
		        catch(Exception $e)
		        {
		            
		        }
		    }
		    ksort($elementTab);
		    $c3data=array("data1");
		    $c3headder=array();
		    foreach($elementTab as $line)
		    {
		        $c3data[]=$line['percent'];
		        $c3headder[]=$line['name'];
		    }
		    $c3data = json_encode($c3data);
		    $c3headder = json_encode($c3headder);
		    echo '<div id="bar_chart'.$idInclude.'" style="min-width:700px;"></div>
                <script type="text/javascript">
                    $(document).ready(function(){
                    var chart = c3.generate({
						bindto: "#bar_chart'.$idInclude.'",
					    data: {
                            columns: ['.$c3data.'],
					        type: "bar",
                            labels: {
                                        format: function(value, ratio, id)
                                            {
                                                if(!value) {   return "No Data";}
                                                else if(value===0) return \'00%\';
                                                else return value+\'%\';
                                            }
                                    },
                            empty: { label: { text: "No Data Available" }   },
						    color: function(color,d)
    						    	{
    						    		if(!d.value)
    						    		{
    						    			return	\'#575759\';
    						    		}
    						    		else if(d.value < '.$param['SeuilCritical'].')
    						    		{
    						    			return \'#da002e\';
    						    		}
    						    		else if(d.value < '.$param['SeuilWarning'].')
    						    		{
    						    			return	\'#ffcb1f\';
    						    		}
    						    		else
    						    		{
    						    			return	\'#83bc00\';
    						    		}
    						        }
					    },
					    bar: {
					        width: { ratio: 0.5 }
					    },
					    axis: {
					        rotated: true,
						    x:{
		                        type: \'category\',
                                tick: { multiline: false},
		                        categories: '.$c3headder.'
		                    },
		                    y:{
		                    	min: 0,
		                    	max: 100,
		                    	padding: 0
		                    }
					    },
					    legend: { show: false }
					});});</script>';
		}
	}
	elseif($param['type']=="noeud" || $param['type']=="groupenoeud")
	{
		$tab_id_node = array();		
		
		if(isset($user) && is_null($user)==false)
		{
			$tab_id_node=nodeOrGroupNode($dbconnection,$param,$user->getId());
		}
		else
		{
			$report_user = Model_Report::getOwnerCanevas($dbconnection,$query['include_canevas_id']);
			$iduser = $report_user;
			$tab_id_node=nodeOrGroupNode($dbconnection,$param,$iduser[0]);
		}	
		if($param['forme']=="donut")
		{
			if($param['onegraph']==true)
			{
				createAvailabilityHtmlItem($param,'donut');
			}
			else
			{
				foreach ($tab_id_node as $node)
				{						
					$listservice = Model_esia::getServices($dbconnection,$node['id']);
					$resultat= StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
					$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
					$listservice=$listservice[0];
					if($node['parent']!=null || $param['type']=="groupenoeud")
					{
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$node['parent'].' - '.$listservice['device_name'].'</p></th></tr></thead><tbody><tr><td>';
					}
					else
					{						
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$listservice['device_name'].'</p></th></tr></thead><tbody><tr><td>';
					}
					$nbr = rand(0,1000);
					CreationDonutHtml($nbr+$node['id']+$node['idgroup'],$resultat,$lang);
				}
			}
		}
		elseif($param['forme']=="tab2")
		{		
			$elementTab = array();
			$temp= array();
			foreach ($tab_id_node as $node)
			{
                //print_r($node);
				$listservice = Model_esia::getServices($dbconnection,$node['id']);
				$resultat= StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
				$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
				$listservice=$listservice[0];
				$elementTab[] = array('groupname'=>$node['parent'],'ip'=>$node['ip'],'device_type'=>$listservice['device_type'],'device_name'=>$node['name'],'percent'=>$resultat['ok']['percent']);
			}
			echo '<table class="tab"><thead><tr valign="top"><th><p>'.$lang['REPORT_AVAILABILITY_GROUPES'].'</p></th><th><p>'.$lang['REPORT_AVAILABILITY_NODES'].'</p></th>';
			if($param['affiche_type']==true)
			{
				echo '<th><p>'.$lang['REPORT_NODE_TYPE'].'</p></th>';
			}
			if($param['affiche_ip']==true)
			{
				echo '<th><p>'.$lang['REPORT_IP_ADD'].'</p></th>';
			}
			echo '<th><p>'.$lang['REPORT_AVAILABILITY_DISPO'].'</p></th></tr></thead><tbody>';
			CreationTabHtml($elementTab,$param,"group");
		}
		elseif($param['forme']=='graphCol')
		{
		    $elementTab = array();
		    foreach ($tab_id_node as $node)
		    {
		        try
		        {
		            $listservice = Model_esia::getServices($dbconnection,$node['id']);
		            $resultat= StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
		            $resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
		            $listservice=$listservice[0];
		            $elementTab[$listservice['device_name']] = array('name'=>$listservice['device_name'],'percent'=>$resultat['ok']['percent']);
		        }
		        catch(Exception $e)
		        {
		            
		        }
		    }
		    ksort($elementTab);
		    $c3data=array("data1");
		    $c3headder=array();
		    foreach($elementTab as $line)
		    {
		        $c3data[]=$line['percent'];
		        $c3headder[]=$line['name'];
		    }
		    $c3data = json_encode($c3data);
		    $c3headder = json_encode($c3headder);
		    echo '<div id="bar_chart'.$idInclude.'" style="min-width:700px;"></div>
                <script type="text/javascript">
                    $(document).ready(function(){
                    var chart = c3.generate({
						bindto: "#bar_chart'.$idInclude.'",
					    data: {
                            columns: ['.$c3data.'],
					        type: "bar",
                            labels: {
                                        format: function(value, ratio, id)
                                            {
                                                if(!value) {   return "No Data";}
                                                else if(value===0) return \'00%\';
                                                else return value+\'%\';
                                            }
                                    },
                            empty: { label: { text: "No Data Available" }   },
						    color: function(color,d)
    						    	{
    						    		if(!d.value)
    						    		{
    						    			return	\'#575759\';
    						    		}
    						    		else if(d.value < '.$param['SeuilCritical'].')
    						    		{
    						    			return \'#da002e\';
    						    		}
    						    		else if(d.value < '.$param['SeuilWarning'].')
    						    		{
    						    			return	\'#ffcb1f\';
    						    		}
    						    		else
    						    		{
    						    			return	\'#83bc00\';
    						    		}
    						        }
					    },
					    bar: {
					        width: { ratio: 0.5 }
					    },
					    axis: {
					        rotated: true,
						    x:{
		                        type: \'category\',
                                tick: { multiline: false},
		                        categories: '.$c3headder.'
		                    },
		                    y:{
		                    	min: 0,
		                    	max: 100,
		                    	padding: 0
		                    }
					    },
					    legend: { show: false }
					});});</script>';
		}
		elseif($param['forme']=="graph")
		{	
	
			if($param['onegraph']=='on') //toujours faux pour couper la fonction
			{
				$listname  = array();
				$json_total = array();
				foreach ($tab_id_node as $node)
				{
					$services = Model_esia::getServices($dbconnection,$node['id']);
					
					$jsontable=getNodeServicesAvailabilities($dbconnection,$node,$services,$end,$interval);
					
					$mt = microtime(true);
					$id = ($mt*10000)%100000;
					$id = $node['id'].$id;
					$services=$services[0];					
					$tab = array();
					$newtab=array();
					$numberofplugin = 0;
					if($param['type']=="noeud")
					{
						array_push($listname , $services['device_name']);					
						////////////////////////////////////////////
						foreach($jsontable as $key => $value)
						{
							$newcmpt = 0;
							if($key!="x")
							{
								foreach($value as $val)
								{
									$tab[$newcmpt]=$val+$tab[$newcmpt];
									$newcmpt++;
								}
								$numberofplugin++;
							}
						}
						$newtab['x']=$jsontable['x'];
						foreach($tab as $key => $val)
						{
							$tab[$key]=$val/$numberofplugin;
						}
						$newtab[$services['device_name']]=$tab;
						$json_total = $json_total+$newtab;
						////////////////////////////////////////////
					}
					else
					{					
						foreach ($param['groupnodeid'] as $groupnode)
						{						
							$query=Model_esia::getGroupDeviceIn($dbconnection,$groupnode);
                            
							$query=$query[0];
                            if(!in_array($query['name'], $listname))
                            {
							    array_push($listname , $query['name']);
                            }
						}			
                        $tab = array();		
						////////////////////////////////////////////
						foreach($jsontable as $key => $value)
						{
							$newcmpt = 0;
							if($key!="x")
							{
								foreach($value as $val)
								{
									$tab[$newcmpt]=$val+$tab[$newcmpt];
									$newcmpt++;
								}
								$numberofplugin++;
							}
						}
						//$newtab['x']=$jsontable['x'];
						foreach($tab as $key => $val)
						{
							$tab[$key]=$val/$numberofplugin;
						}
						//$newtab[]=$tab;
                        $json_total[$node['parent']] = $tab;
					}	
				}
                $json_total['x']=$jsontable['x'];
				$json_total = json_encode($json_total);		
				
				echo '<table class="tab"><thead><tr valign="top"><th><p>'.(implode(" & ",$listname )).'</p></th></tr></thead><tbody><tr><td>';
				CreationGraphNoeudHtml($id,$json_total,$interval,'line');
			}
			else
			{
				foreach ($tab_id_node as $node)
				{
					$services = Model_esia::getServices($dbconnection,$node['id']);
					
					$jsontable=getNodeServicesAvailabilities($dbconnection,$node,$services,$end,$interval);
					
					$mt = microtime(true);
					$id = ($mt*10000)%100000;
					$id = $node['id'].$id;
					$services=$services[0];
					$json = json_encode($jsontable);
					if($param['type']=="groupenoeud")
					{
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$node['parent'].'</p></th></tr></thead><tbody><tr><td>';
					}
					else
					{
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$services['device_name'].'</p></th></tr></thead><tbody><tr><td>';
					}					
					CreationGraphNoeudHtml($id,$json,$interval,'area');
				}
			}
		}
		elseif ($param['forme']=="abre")
		{
			if($param['onegraph']==true)
			{
				$listname  = array();
				foreach ($tab_id_node as $node)
				{
					$listservice = Model_esia::getServices($dbconnection,$node['id']);
					$resultat= StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
					$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
					$val = $val + $resultat['ok']['percent'];
					$listservice=$listservice[0];
					if($param['type']=="groupenoeud")
					{
						array_push($listname ,$node['parent']);
					}
					else
					{
						array_push($listname , $listservice['device_name']);
					}
				}
				echo '<table class="tab"><thead><tr valign="top"><th><p>'.(implode(" & ",$listname )).'</p></th></tr></thead><tbody><tr><td>';
				$resultat['ok']['percent'] = $val/count($tab_id_node);
				$state=returnState($resultat['ok']['percent'],$param);
				CreationAbreviationHtml($lang,$state);
			}
			else
			{
				foreach ($tab_id_node as $node)
				{
					$listservice = Model_esia::getServices($dbconnection,$node['id']);
					$resultat=StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
					$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
					$state=returnState($resultat['ok']['percent'],$param);
					$listservice=$listservice[0];
					if($node['parent']!=null || $param['type']=="groupenoeud")
					{
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$node['parent'].'</p></th></tr></thead><tbody><tr><td>';
					}
					else
					{						
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$listservice['device_name'].'</p></th></tr></thead><tbody><tr><td>';
					}
					CreationAbreviationHtml($lang,$state);
				}
			}
		}
		elseif($param['forme']=="token" || $param['forme']=="rectangle")
		{
			if ($param['forme']=="token")
			{
				$radius="50%";
			}
			else
			{
				$radius="5px";
			}
				
			if($param['onegraph']==true)
			{
				$listname  = array();
				foreach ($tab_id_node as $node)
				{
					$listservice = Model_esia::getServices($dbconnection,$node['id']);
					$resultat= StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
					$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
					$val = $val + $resultat['ok']['percent'];
					$listservice=$listservice[0];
					if($param['type']!="groupenoeud")					
					{
						array_push($listname , $listservice['device_name']);
					}
				}
				
				
				if($param['type']=="groupenoeud")
				{
					foreach ($param['groupnodeid'] as $groupnode)
					{
						$query=Model_esia::getGroupDeviceIn($dbconnection,$groupnode);
						$query=$query[0];
						array_push($listname , $query['name']);
					}
				}
				
				echo '<table class="tab"><thead><tr valign="top"><th><p>'.(implode(" & ",$listname )).'</p></th></tr></thead><tbody><tr><td>';
				$resultat['ok']['percent'] = $val/count($tab_id_node);
				$state=returnState($resultat['ok']['percent'],$param);
				CreationTokenOrRectangleHtml($state,$radius);
			}
			else
			{
				foreach ($tab_id_node as $node)
				{				
					$listservice = Model_esia::getServices($dbconnection,$node['id']);
					$resultat=StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
					$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
					$state=returnState($resultat['ok']['percent'],$param);
					$listservice=$listservice[0];
					if($node['parent']!=null || $param['type']=="groupenoeud")
					{
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$node['parent'].'</p></th></tr></thead><tbody><tr><td>';
					}
					else
					{						
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$listservice['device_name'].'</p></th></tr></thead><tbody><tr><td>';
					}
					CreationTokenOrRectangleHtml($state,$radius);
				}
			}
		}
		elseif($param['forme']=="gauge")
		{
			if($param['onegraph']==true)
			{
				createAvailabilityHtmlItem($param,'gauge');
			}
			else
			{
				foreach ($tab_id_node as $node)
				{
					$listservice = Model_esia::getServices($dbconnection,$node['id']);
					$resultat= StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
					$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
					$listservice=$listservice[0];					
					if($node['parent']!=null || $param['type']=="groupenoeud")
					{
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$node['parent'].'</p></th></tr></thead><tbody><tr><td>';
					}
					else
					{						
						echo '<table class="tab"><thead><tr valign="top"><th><p>'.$listservice['device_name'].'</p></th></tr></thead><tbody><tr><td>';
					}
					$nbr = rand(0,1000);
					CreationGaugeHtml($nbr+$node['id'],$resultat,$lang);
				}
			}
		}
	}		
	echo '</tbody></table></div></section>';
	//echo '</tbody></table></div></div></section>';
}
elseif($action=="update")
{
	$template_path = $path.'/plugin/report/templates/';
	$param = json_decode($query['include_parameter'],true);

	$rightWriting=$_GET['writingright'];	
	if(!isset($rightWriting))
	{
		$rightWriting=$_POST['writingright'];
	}
	$smarty->assign('rightWriting',$rightWriting);
	
	$smarty->assign('block',$query);
	$smarty->assign('param',$param);
	$taille = explode("px", $param['title']['style']['font-size']);
	$smarty->assign('TaillePoliceTitle',$taille[0]);
	$taille = explode("px", $param['description']['style']['font-size']);
	$smarty->assign('TaillePoliceDescr',$taille[0]);
	$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
	$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	$smarty->assign('forme',$param['forme']);
	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			// Param Title
			$param['title']['text']=$_POST["blockname"];
			$TaillePoliceTitle = $_POST["namesize"];
			$param['title']['style']['font-size']=$TaillePoliceTitle."px";
			$param['title']['style']['text-align']=$_POST["nameposition"];
			$param['title']['style']['color']=$_POST["blockcolor"];
			
			// Param Descr
			$param['description']['text']=$_POST["blockdescription"];
			$TaillePoliceDescr=$_POST["blocksize"];
			$param['description']['style']['font-size']=$TaillePoliceDescr."px";
			$param['description']['style']['text-align']=$_POST["desciptionposition"];
		
			// Service & Noeud
			if($param['type']=='service')
			{
				$param['nodeid']=$_POST['nodes'];
				$param['serviceid']=$_POST['services'];
			}
			elseif ($param['type']=='noeud')
			{
				$param['nodeid']=$_POST['nodes'];
			}
			else
			{
				$param['groupnodeid']=$_POST['groupnodes'];
			}
			
			// Seuil de Warning et Critical
			$param['SeuilCritical']=$_POST['SeuilCritical'];
			$param['SeuilWarning']=$_POST['SeuilWarning'];
	
			// Seuil de Warning et Critical
			if( empty($_POST['calcunknown']) )	$_POST['calcunknown'] = 'none';
			if( empty($_POST['calcwarning']) )	$_POST['calcwarning'] = 'none';
			if( empty($_POST['calccritical']) )	$_POST['calccritical'] = 'none';
			$param['calcunknown']=$_POST['calcunknown'];
			$param['calcwarning']=$_POST['calcwarning'];
			$param['calccritical']=$_POST['calccritical'];
			
			// Affichage colonne
			$param['affiche_type']=$_POST['type'];
			$param['affiche_ip']=$_POST['add_ip'];
			
			// Forme
			$param['forme']=$_POST['forme'];
			
			// Une representation ou plusieur
			$param['onegraph']=$_POST['onegraph'];
			
			$paramSave = json_encode($param);
		
			$query=Model_Report::getReportIncludeBlock($dbconnection,$_POST['blockid']);
			$query= $query[0];

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
			
			if($param['calcunknown']='none' && $param['calcwarning']== 'none' && $param['calccritical']=='none'){
				$smarty->assign('l_warning',$lang['REPORT_AVA_UNCHECKED_ALLBOXES']);
				$smarty->assign('l_success',$lang['UPDATE_REPORT_SUCCESS']);
			}
			else{
				$smarty->assign('l_success',$lang['UPDATE_REPORT_SUCCESS']);
			}
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		
		$smarty->assign('block',$query);
		$smarty->assign('param',$param);
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('TaillePoliceTitle',$taille[0]);
		$taille = explode("px", $param['description']['style']['font-size']);
		$smarty->assign('TaillePoliceDescr',$taille[0]);
		$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
		$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
		$smarty->assign('forme',$param['forme']);
	}
		
	$listnode = array();
	//Récupération des services
	if($param['type']=="service")
	{
		if(!empty($param['serviceid']))
		{
			$services = Model_esia::getServices($dbconnection,null,$param['serviceid']);		
			foreach($services as $ser)
			{
				if(!in_array($ser['device_id'],$listnode))
					$listnode[]=$ser['device_id'];
			}
			foreach($services as $ser)
			{
				$listservice[]=$ser['id'];
			}
		}
		$smarty->assign('serviceid',$listservice);
	
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();

		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$listnode))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected			
			);
		}
	}
	elseif($param['type']=="noeud")
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$param['nodeid']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected
						
			);
		}
	}
	else
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());	
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$param['groupnodeid']))
			{
				$selected='yes';
			}
			
			$list_group_node[]=array('id'=>$node['id'],
					'name'=>$node['name'],
					'selected'=>$selected);
		}
	}
	
	$smarty->assign('adm_list_node', $list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	$smarty->assign('action','update');
	$smarty->display($template_path.'availability.html');
}
elseif($action =="getservice")
{
	$template_path = $path.'/plugin/report/templates/';
	if(isset($_GET['nodeid']))
	{
		$tablenodeid = json_decode($_GET['nodeid']);
		$list=array();
		foreach($tablenodeid as $nodeid)
		{
			$node = Model_esia::InstanceNode($dbconnection, $nodeid);
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				foreach ($services as $service)
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
					$list[$service['id']]=$node->getName().' > '.$common_name;
				}
			}
		}
		echo json_encode($list);
		exit(0);
	}
}
elseif($action =="getgroupnode")
{
	$template_path = $path.'/plugin/report/templates/';
	if(isset($_GET['groupnodeid']))
	{
		$tablegroupnodeid = json_decode($_GET['groupnodeid']);
		$list=array();
		foreach($tablegroupnodeid as $groupnodeid)
		{
			$groupnode = Model_esia::getGroupDeviceIn($dbconnection, $groupnodeid); 
			foreach ($groupnode as $node)
			{
				$list[$node['id']]=$node['name'].' > '.$node['child'];
			}
		}
		echo json_encode($list);
		exit(0);
	}
}

function getAvailabilityList($dbconnection,$node,$service,$end,$interval){
	if( $interval == 1 ) {//One day only
		$date = new DateTime();
		$date->setTime(0,0,0);
		$end_date_ts = $date->getTimestamp();
		$end_date_ts--;
	}
	
	if( $interval == 1 ){
		$avai = Model_esia::getDayAvailability($dbconnection,$node,$service,$end_date_ts);
		
	}
	else{
		$avai = Model_esia::getAvailability($dbconnection,$node,$service,$end,$interval);
	}
	return $avai;
}

function parseAvailabilityDate($key,$interval){
	if( $interval == 1){
		$exp =  explode(' ',$key);
		$day = $exp[0];
		$hour = $exp[1];
		$ret = "$day $hour:00:00";
	}
	else
	{
		$ret = $key." 00:00:00";
	}
	return $ret;
}

function getNodeServicesAvailabilities($dbconnection,$node,$services,$end,$interval){	
	$first = true;
	$jsontable=array();
	foreach($services as $service)
	{
		$avai = getAvailabilityList($dbconnection,$node['id'],$service['id'],$end,$interval);

		if( $first ){
			$first = false;
			foreach ($avai as $time => $value){
				$jsontable['x'][] = parseAvailabilityDate($time,$interval);
			}
		}
		
		foreach ($avai as $time => $value)
		{
			if(is_nan($value))
			{
				$value=0;
			}
			else
			{
				$value=intval($value);
			}
			$jsontable[$service['name']][] = $value;
		}
	}
	return $jsontable;
}

function createAvailabilityHtmlItem($param,$type){
	$listname  = array();
	foreach ($tab_id_node as $node)
	{
		$listservice = Model_esia::getServices($dbconnection,$node['id']);
		$resultat= StateAvailability($dbconnection,$listservice,$node['id'],$end,$interval);
		$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
		$val = $val + $resultat['ok']['percent'];
		$listservice=$listservice[0];
		if($param['type']!="groupenoeud")
		{
			array_push($listname , $listservice['device_name']);
		}
		$i = ($i + $node['id'])*2;
	}
	
	if($param['type']=="groupenoeud")
	{
		foreach ($param['groupnodeid'] as $groupnode)
		{
			$query=Model_esia::getGroupDeviceIn($dbconnection,$groupnode);
			$query=$query[0];
			array_push($listname , $query['name']);
		}
	}
	
	echo '<table class="tab"><thead><tr valign="top"><th><p>'.(implode(" & ",$listname )).'</p></th></tr></thead><tbody><tr><td>';
	$resultat['ok']['percent'] = $val/count($tab_id_node);
	
	if ($type == 'donut') 			CreationDonutHtml($i,$resultat,$lang);
	elseif ($type == 'gauge') 		CreationGaugeHtml($i,$resultat,$lang);
}

function createHtmlItem($param,$type){
	$listname = array();
	foreach ($param['nodeid'] as $node)
	{
		$listservice = Model_esia::getServices($dbconnection,$node);
		foreach ($param['serviceid'] as $idService)
		{
			$name=SearchIfContainService($listservice,$idService);
			if($name!=false)
			{
				$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);
				$resultat=Model_esia::getTimeErrorAvailability($dbconnection,$node,$idService,$end,$interval);
				$resultat = eliminateErreurAvaibility($resultat,$param['calcunknown'],$param['calcwarning'],$param['calccritical']);
				$val = $val + $resultat['ok']['percent'];
				array_push($listname , $name['device_name']." : ".$CommonName);
				$i = $i + $idService;
			}
		}
	}
	echo '<table class="tab"><thead><tr valign="top"><th><p>'.(implode(" & ",$listname)).'</p></th></tr></thead><tbody><tr><td>';
	$resultat['ok']['percent'] = $val/count($param['serviceid']);
	$state = returnState($resultat['ok']['percent'],$param);
	
	if($type == 'abreviation' ) 	CreationAbreviationHtml($lang,$resultat);
	elseif ($type == 'rectangle') 	CreationTokenOrRectangleHtml($state,'5px');
	elseif ($type == 'token') 		CreationTokenOrRectangleHtml($state,'50%');
	elseif ($type == 'donut') 		CreationDonutHtml($i,$resultat,$lang);
	elseif ($type == 'gauge') 		CreationGaugeHtml($i,$resultat,$lang);
}

/**
 * @brief fais la difference entre noeud et groupe de noeud et retourne les bons param's
 * @detail retourne un array contenant les paramètres utlisés qu'importe que ce soit un noeud ou groupe de noeud
 * @param PDO $dbconnection
 * @param array $param contient les param du block
 * @retval unknown[][]|NULL[][]
 * @throw void
 */

function nodeOrGroupNode($dbconnection,$param,$userid)
{
	$tab_id_node=array();
	if($param['type']=="noeud")
	{
		foreach($param['nodeid'] as $val)
		{
			$node=Model_esia::InstanceNode($dbconnection,$val);
			$tab_id_node[] = array('id'=>$val,'parent'=>$node->getGroup(),'name'=>$node->getName(),'ip'=>$node->getIPAddress());
		}
	}
	else
	{
		foreach ($param['groupnodeid'] as $groupnode )
		{
			$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$groupnode);
			//$tab_group_node = Model_esia::getNodeList($dbconnection,null,$groupnode,$t_return = Model_esia::NODE_INSTANCE);
			foreach ($tab_group_node as $node)
			{
			    $tab_id_node[] = array('id'=>$node->getId(),'name'=>$node->getName(), 'parent'=>$node->getGroup(),'idgroup'=>$node->getGroupId(),'ip'=>$node->getIPAddress());
			}
		}
	}
	return $tab_id_node;
}

/**
 @brief retourne le code d'erreur
 @detail retourne le code d'erreur en fonction des seuils de critique et de warning
 @params integer $resultat contient la valeur de disponibilite du service | noeud
 @params array $param les valeurs des deux seuils
 @retval	0|1|2
 @throw void
 */

function returnState($resultat,$param)	
{
	if($resultat>$param['SeuilCritical'])
	{
		if($resultat>$param['SeuilWarning'])
		{
			return 0; // OK
		}
		else
		{
			return 1; // WARNING
		}
	}
	else
	{
		return 2; // CRITICAL
	}
}

/**
 @brief retourne array contenant service plugin et device name
 @params integer $idser contient l'identifiant d'un service
 @params array $array liste des services
 @retval	false | array $ret contenant 
 @throw void
 */

function SearchIfContainService($array, $idser) 
{
	$ret=array();
	foreach ($array as $Element => $tab_elem)
	{
		if ($tab_elem['id'] == $idser) 
		{
			$ret['plugin_name']=$tab_elem['check_plugin_name'];
			$ret['service_name']=$tab_elem['name'];
			$ret['device_name']=$tab_elem['device_name'];
			$ret['device_type']=$tab_elem['device_type'];			
			return $ret;
		}
	}
	return false;
}

/**
 @brief retourne le code d'erreur de la disponibilite du noeud
 @detail Calcule la moyenne de disponibilite des services du noeud 
 @params $dbconnection permet d'acceder à la base de donnée
 @params array $listservice liste des services
 @params integer $node contient l'identifiant du noeud
 @params date $end contient la date 
 @params interval $interval contient l'interval
 @retval	array $ret contenant la valeur de disponibilite du noeud
 */

function StateAvailability($dbconnection,$listservice,$node,$end,$interval)
{
	$resultat=array();
	$resultat['ok']['percent']=0;
	foreach ($listservice as $Service)
	{
		$tmp=array();					
		$tmp=Model_esia::getTimeErrorAvailability($dbconnection,$node,$Service['id'],$end,$interval);
		if($tmp['ok']['percent']<0)
		{
			$tmp['ok']['percent']=0;
		}
		$resultat['ok']['percent']+=$tmp['ok']['percent'];
		$resultat['warning']['percent']+=$tmp['warning']['percent'];
		$resultat['critical']['percent']+=$tmp['critical']['percent'];
		$resultat['unknown']['percent']+=$tmp['unknown']['percent'];
	}
	$nservices = count($listservice);
	$resultat['ok']['percent']=($resultat['ok']['percent'])/$nservices;
	$resultat['warning']['percent']=($resultat['warning']['percent'])/$nservices;
	$resultat['critical']['percent']=($resultat['critical']['percent'])/$nservices;
	$resultat['unknown']['percent']=($resultat['unknown']['percent'])/$nservices;
	return $resultat;
}

/**
 @brief retourne le code html du donut
 @params integer $id id du service
 @params array $resultat contient les valeurs à mettre dans le donut
 */

function CreationDonutHtml($id,$resultat,$lang)
{						
	$reste = 100-$resultat['ok']['percent'];
	echo ' <div id="donut'.$id.'" style="height:300px; text-align: center; "></div>
					</td>
				</tr>
          	<script type="text/javascript">
			<!-- {literal} -->
            	$(document).ready(function()
                {
	            	var chart = c3.generate({
                     			bindto: "#donut'.$id.'",
                    		data: {       
                     				columns: [["'.$lang["REPORT_AVAILABILITY"].'", '.number_format($resultat['ok']['percent'],2).'],["'.$lang["REPORT_NO_AVAILABILITY"].'",'.number_format($reste,2).']],
                      				type:"donut"
                    				},
                    		color: {
                       				pattern: ["#83bc00", "#ffcb1f", "#da002e", "#575759", "#3263c5"]
                    				},
                    		size: {
                    				height: 300,
                    				width:300,
                    		   	},
	                    	donut: {
                      				width:70
	                    			},
                    		tooltip: {
                        			format: {
	                           value: function (value, ratio, id) {
                           						var format = d3.format(',');
                           						return format(value);
	                           					}
                         					}
                      				}
								});
                			});
         		<!-- {/literal} -->
      			</script>';
}

/**
 @brief retourne le code html de l'abreviation
 @params array $lang contient les traductions
 @params integer $state contient la valeur calculer
 */

function CreationAbreviationHtml($lang,$state)
{
	if($state>=2)
	{
		echo '<p class="widget-abbreviation" style="color:#da002e;">'.$lang['REPORT_AVA_CRITICAL'].'</p>';
	}
	elseif ($state>=1)
	{
		echo '<p class="widget-abbreviation" style="color:#ffcb1f;">'.$lang['REPORT_AVA_WARNING'].'</p>';
	}						
	else
	{
		echo '<p class="widget-abbreviation" style="color:#83bc00;">'.$lang['REPORT_AVA_OK'].'</p>';
	}
	echo '</td></tr>';
}

/**
 @brief retourne le code html du rectangle
 @params string $radius contient la valeur pour le style
 @params integer $state contient la valeur calculer
 */

function CreationTokenOrRectangleHtml($state,$radius)
{				
	if($state>=2)
	{
		echo '<div class="EventCritical" style="width:150px; height:150px; border-radius:'.$radius.';margin:auto;" ></div>';
	}
	elseif ($state>=1)
	{
		echo '<div class="EventWarning" style="width:150px; height:150px; border-radius:'.$radius.'; margin:auto;" ></div>';
	}
	else
	{
		echo '<div class="EventOK" style="width:150px; height:150px; border-radius:'.$radius.'; margin:auto;" ></div>';
	}
	echo '</td></tr>';
}

/**
 @brief retourne le code html du rectangle
 @params integer $id id du service
 @params array $resultat contient la valeur calculer
 */

function CreationGaugeHtml($id,$resultat,$lang)
{
	echo '<div id="gauge'.$id.'" style="height:300px; text-align: center;"></div></td></tr>
			<script type="text/javascript">
			<!-- {literal} -->
			$(document).ready(function()
			{
				var chart = c3.generate({
						bindto: "#gauge'.$id.'",
						data: {
							columns: [["'.$lang["REPORT_AVAILABILITY"].'", '.number_format($resultat['ok']['percent'], 2).']],
							type:"gauge"
							},
						color: {
							pattern: ["#83bc00","#ffcb1f","#da002e", "#575759", "#3263c5"]
							},
						size: {
							height: 300,
							width:300,
							},
						gauge: {
							label:{
								format: function(value, ratio){
									return value;
								},
							},
							min: 0,
							max: 100,
							units: "%" 
						},
						tooltip: {
							format: {
								value: function (value, ratio, id) {
									var format = d3.format(',');
									return format(value);
								}
					}
				}
			});
		});
		<!-- {/literal} -->
		</script>';
}

/**
 @brief retourne le code html du graphique de service
 @params integer $idService id du service
 @params array $pourcent contient la valeur calculer
 @params array $lang contient les traductions
 */

function CreationGraphServiceHtml($pourcent,$idService,$lang,$interval)
{
	$json = array();
	$json['x'] = array();
	$json[$lang['REPORT_GRAPHE_NAME_ABSCISSE']] = array();
	foreach($pourcent as $key => $value)
	{
		$json['x'][] = $key;
		if($value>0)
		{
			$json[$lang['REPORT_GRAPHE_NAME_ABSCISSE']][]= $value;
		}
		else
		{
			$json[$lang['REPORT_GRAPHE_NAME_ABSCISSE']][]= 0;
		}
	}
	$json=json_encode($json, JSON_PRETTY_PRINT);
	
	echo '<div id="showGraph'.$idService.'" style="min-width:700px;"></div></td></tr><br>
    			<script type="text/javascript">
				<!-- {literal} -->
    			$(document).ready(function(){
			       	var serviceid = '.$idService.';
            		var yName = "percent";
	                
			       	if( yName == "percent")
			       	{
						valYmin = 10;
						valYmax = 100;
					}
			       	else
			       	{
						valYmin = undefined;
						valYmax = undefined;
					}
	
    	           	window["chart"+serviceid] = c3.generate({
                      					bindto: "#showGraph"+serviceid,
                      					data: {	x: "x",
                          						xFormat: "%Y-%m-%d %H:%M:%S",
                          						json:'.$json.',
                          						type:"area",
                          						types:{ 
                          							in: "spline",
                           							out: "area"
													}
                   	},
                  						
                    color:{
                       			pattern: ["#83bc00", "#ffcb1f", "#da002e", "#575759", "#3263c5", "#a833c4", "#e20e6f", "#0ee29b", "#e2720e", "#e2220e"]
                   			},
             
					zoom: {
	                   				enabled: true
                   				},
           
								point: {
                   					show: false
                   				},
	
									axis: {
                       					x: { type: "timeseries",
                           				 	tick: { 
                          							';

					                    if($interval==1)
										{
											echo 'format: "%H:%M",';
										}
										else 
										{
											echo 'format: "%d-%m",';
										}
										echo '
													rotate: 75,
                               						fit:false
                           					  	},
                           				 	label: { position: "outer-center"}
                       						},
                       					y: {
											min : valYmin,
											max : valYmax,
                       						show: true,
                          				 	label: { text: yName,
                           						  	position:"outer-middle"
                           							},
                           					tick: { format: function(d)
                           							{
														if( yName == "percent")
                               							{
	                               							return d+" %";
                               							}
														else if( yName == "Celsius")
														{
	                                  						return d+" °";
                               							}
														else if( yName == "second" || yName == "ms")
														{
	                                  						return d;
                               							}
														else
                               							{
	                                  						return convertByte(d);
                               							}
                           							}
                          						}
                       					}
	                      			}
                   				});
           					});
       					<!-- {/literal} -->
    					</script>
    					</br>';
}

/**
 @brief retourne le code html du graphique de noeud
 @params integer $id identifiant du noeud
 @params json $json contient la valeur du graph
 */

function CreationGraphNoeudHtml($id,$json,$interval,$type='area')
{
	echo '<div id="showGraph'.$id.'" style="min-width:700px;"></div></td></tr><br>
    			<script type="text/javascript">
				<!-- {literal} -->
    			$(document).ready(function(){
			       	var serviceid = '.$id.';
            		var yName = "percent";
	    
			       	if( yName == "percent")
			       	{
						valYmin = 10;
						valYmax = 100;
					}
			       	else
			       	{
						valYmin = undefined;
						valYmax = undefined;
					}

    	           	window["chart"+serviceid] = c3.generate({
                      					bindto: "#showGraph"+serviceid,
                      					data: {	x: "x",
                          						xFormat: "%Y-%m-%d %H:%M:%S",
                          						json:'.$json.',
                          						type:"'.$type.'",
                   	},

                    color:{
                       			pattern: ["#83bc00", "#ffcb1f", "#da002e", "#575759", "#3263c5", "#a833c4", "#e20e6f", "#0ee29b", "#e2720e", "#e2220e"]
                 			},

					zoom: {
                   				enabled: true
               				},
   
							point: {
               					show: false
               				},

                          		axis: {
                   					x: { type: "timeseries",
                       				 	tick: { 
                          						';

					                    if($interval==1)
										{
											echo 'format: "%H:%M",';
										}
										else 
										{
											echo 'format: "%d-%m",';
										}
										echo '
                  								rotate: 75,
                           						fit:false
                       					  	},
                       				 	label: { position: "outer-center"}
                   						},
                   					y: {
										min : valYmin,
										max : valYmax,
                   						show: true,
                       				 	label: { text: yName,
                       						  	position:"outer-middle"
                       							},
                       					tick: { format: function(d)
                       							{
													if( yName == "percent")
                           							{
	                           							return d+" %";
                           							}
													else if( yName == "Celsius")
													{
	                               						return d+" °";
                           							}
													else if( yName == "second" || yName == "ms")
													{
	                               						return d;
                           							}
													else
                           							{
	                               						return convertByte(d);
                           							}
                       							}
                       						}
                   					}
	                   			}
               				});
           				});
       				<!-- {/literal} -->
    				</script>
    				</br>';
}

/**
 @brief retourne le code html du tableau de disponibilité
 @params integer $elemenTab contient les elements du tableaux
 */

function CreationTabHtml ($elementTab,$param,$type)
{	
	foreach($elementTab as $value)
	{
		echo '<tr>';		
		echo'<td><p style="word-wrap:break-word">'.$value['groupname'].'</p></td>';
		echo'<td><p style="word-wrap:break-word">'.$value['device_name'].'</p></td>';
		if($type=="service")
		{
			echo'<td><p style="word-wrap:break-word">'.$value['CommonName'].'</p></td>';
		}
		if($param['affiche_type']==true)
		{
			echo'<td><p style="word-wrap:break-word">'.$value['device_type'].'</p></td>';
		}
		if($param['affiche_ip']==true)
		{
			echo'<td><p style="word-wrap:break-word">'.$value['ip'].'</p></td>';
		}
		if($value['percent']< $param['SeuilCritical'])
		{
			echo'<td><p style="text-align: center" class="EventCritical_Incident">'.number_format($value['percent'], 2).'%</p></td>';
		}
		elseif ($value['percent']< $param['SeuilWarning'])
		{			
			echo'<td><p style="text-align: center" class="EventWarning_Incident">'.number_format($value['percent'], 2).'%</p></td>';
		}
		elseif ( stripos($value['percent'],'nan')!==FALSE )
		{			
			echo'<td><p style="text-align: center" class="EventUnknown_Incident">NaN</p></td>';
		}
		else
		{							
			echo'<td><p style="text-align: center" class="EventOK_Incident">'.number_format($value['percent'], 2).'%</p></td>';	
		}
		echo '</tr>';
	}
}

/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}
function eliminateErreurAvaibility($percent, $inconnu='on',$warning='on',$critical='on')
{
	if(!isset($percent['ok']['nbrsec']))	$percent['ok']['nbrsec']=0;
	if(!isset($percent['ok']['percent']))	$percent['ok']['percent']=0;
	
	if($inconnu !='on' && isset($percent['unknown']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['unknown']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['unknown']['percent'];
        $percent['unknown']=array('nbrsec'=>0,'percent'=>0);
    }
    if($warning !='on' && isset($percent['warning']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['warning']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['warning']['percent'];
        $percent['warning']=array('nbrsec'=>0,'percent'=>0);
    }
    if($critical !='on' && isset($percent['critical']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['critical']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['critical']['percent'];
        $percent['critical']=array('nbrsec'=>0,'percent'=>0);
    }
    if($percent['ok']['percent'] > 100)
    {
        $percent['ok']['percent']=100;
    }
    return $percent;
}
?>
