<?php

/**
 * @name graphique
 * @description construction des graphiques de service
 *		Tous les blocs graphiques de service passent par ce code pour construire le graph
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */


if(empty($_SERVER['DOCUMENT_ROOT'])) 
{
	$is_cli=true;
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}

$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_esia.php';
include_once $path.'/plugin/report/Model_Report.php';;

if(!$is_cli)
{
	include_once '/usr/local/esia/public_html/common.php';
}

$SHORT_OPTS="a:i:s:e:l:";
$LONG_OPTS=array("action:","id:","start:","end:","language:");
if((isset($_POST['blockid']))&&!empty($_POST['blockid'])) // Lors de la modification du bloc
{
	$idInclude= $_POST['blockid'];
	$action= $_GET['action'];
}
elseif((isset($_GET['id'])) &&!empty($_GET['id'])) // Lors de l'ajout du bloc
{
	$idInclude=$_GET['id'];
	$action=$_GET['action'];
}
else // Lors de l'appel par repor_generate.php
{
	$options = getopt($SHORT_OPTS, $LONG_OPTS);
	
	$action	  = getParam($options,"action","a");
	$idInclude= getParam($options,"id","i");
	$start	  = getParam($options,"start","s");
	$end	  = getParam($options,"end","e");
	$language = getParam($options,"language","l");
	
	include $path.'/plugin/report/lang/'.$language.'.php';
	include $path.'/lang/'.$language.'/common_plugin_name.php';
	
	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
}

$extension_name_graph=array("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z");
$rrdpath='/usr/local/esia/public_html/data/rra/';
$query=Model_Report::getReportIncludeBlock($dbconnection,$idInclude);
$query= $query[0];

if($action=="generate")
{	
	$DateStart = new DateTime($start);
	$end = new DateTime($end);
	$diff = $DateStart->diff($end);
	
	$param = json_decode($query['include_parameter'],true);
	$Type = $param['type'];
	
	echo '<div class="clear"></div>';
		echo '<section class="blockView">
          		<div class="blockView_title">
	          		<h3 style="text-align:'.$param['title']['style']['text-align'].';
							font-size:'.$param['title']['style']['font-size'].';
							color:'.$param['title']['style']['color'].'"
							><p>'.$param['title']['text'].'</p></h3>
        		</div>
        		<div class="pad">
	          		<p style="text-align:'.$param['description']['style']['text-align'].';
							font-size:'.$param['description']['style']['font-size'].'"
								>'.$param['description']['text'].'</p>';

	foreach ($param['nodeid'] as $node)
	{
		$listservice = Model_esia::getServices($dbconnection,$node);
		foreach ($param['serviceid'] as $idService)
		{
			$name=SearchIfContainService($listservice,$idService);
			if($name!=false)
			{
				$CommonName = Model_esia::getCommonName($lang, $name['service_name'], $name['plugin_name']);									
					
				$service = Model_esia::getServices($dbconnection,null,$idService);
				$service = $service[0];
				//on recupère les données
				$query= $dbconnection->prepare("SELECT service_id,service_name,service_parameter,service_last_stdout,device_name,plugin_name,
											rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_vertical_label,rrd_graph_color,rrd_graph_type,rrd_regex_threshold,rrd_graph_num
										FROM esia_services
										JOIN esia_device ON device_id = service_device_id
										JOIN esia_plugins ON plugin_id = service_plugin_id
										JOIN rrd_plugins ON rrd_plugin_id=service_plugin_id WHERE service_id=? ORDER BY rrd_graph_type,rrd_name;");
				$ret = $query->execute(array($idService));
				if($ret===false)
				{
					$err = $query->errorInfo();
					echo "DB error: ".$err[2]."\n";
				}
				$arr_rrd=$query->fetchAll(PDO::FETCH_OBJ);				
				//liste les information pour générer le graphique et les sépares suivant leurs numéros (clé rrd_graph_num)
				$list_file=array();
				foreach($arr_rrd as $row)
				{
					$filename = $rrdpath.$row->device_name.'_'.$row->plugin_name.$row->service_id.$row->rrd_graph_num.'.rrd';
					if(is_file($filename) && !in_array($filename, $list_file))
					{
						$list_file[]=$filename;
					}
				}		
				
				$parameter = array();
				$convertRRD2C3 = array('AREA'=>'area-spline',
						'LINE1'=>'spline');
				$convertRRDLabel2C3 = array('second'=>'second',
						'ms'=>'millisecond',
						'percent'=>'percent',
						'bps'=>'bps',
						'packet/s'=>'packetps',
						'temperature'=>'Celsius',
						'connections'=>'number',
						'Bytes' => 'bytes');
				foreach($arr_rrd as $row)
				{
					$parameter[$row->rrd_name] = array('name'=>$row->rrd_name,'unity'=>$row->rrd_vertical_label,
							'type'=>$convertRRD2C3[$row->rrd_graph_type],
							'color'=>$row->rrd_graph_color);
				}
				$globaljsonC3 = array();
				foreach($list_file as $file)
				{
					$ret = rrd_fetch($file, array( "AVERAGE", "--start",$DateStart->getTimestamp(), "--end", $end->getTimestamp()));
					//suppression des caractère NaN de rrd.
					$result="";
					//$date=array('x');
					$data = array();
					$position=array();
					$global = array();
					$jsontable=array();
					$dateTable = $ret['data'];
					foreach ($ret['data'] as $datasource => $data)
					{
						foreach ($data as $time => $value) {
							$jsontable['x'][] = date('Y-m-d G:i:s',$time);
						}
						array_pop($jsontable['x']);
						break;
					}
					//$j = 0;
					foreach ($ret['data'] as $datasource => $data)
					{
						$global['parameter'][] =$parameter[$datasource];
						//$position[$datasource]=$i;
						foreach ($data as $time => $value)
						{
							if(is_nan($value))
							{
								$value=0;
							}else{
								$value=round($value,2);
							}
							$jsontable[$datasource][] = $value;
						}
						array_pop($jsontable[$datasource]);						
					}
					$global['data'] = $jsontable;
					$globaljsonC3[] = $global;
				}

				
				for($i=0 ;$i < count($globaljsonC3);$i++)
				{
					$jsonData = json_encode($globaljsonC3[$i]['data']);
					$jsonParameter = json_encode($globaljsonC3[$i]['parameter'][0]);
					$idGraph = $idService.$extension_name_graph[$i]; // /!!\ probl ID
					$out=json_decode($jsonParameter,true);

					$add_plugin_name = '';
					if($param['affiche_technical_name']==true){
						$add_plugin_name =  $name['service_name'];
						$add_plugin_name = " ($add_plugin_name)";
					}
									
					echo ' <table class="tab"><thead><tr valign="top"><th><p>'.$name['device_name'].' : '.$CommonName.$add_plugin_name.'</p></th></tr></thead><tbody><tr><td>
							<div id="Graph'.$idGraph.'" style="min-width:700px;"></div>
								</td>
								</tr>
          						<script type="text/javascript">

					              <!-- {literal} -->
					
					            $(document).ready(function() {
					
					                      var yName = "'.$out['unity'].'";
					              			                        
					                      window["chart'.$idGraph.'"] = c3.generate({
					                      bindto: "#Graph'.$idGraph.'",
					                      data: {
					                          x: "x",
					                          xFormat: "%Y-%m-%d %H:%M:%S",
											  json:'.$jsonData.',
					                      	  type:"area",
					                          types:{
					                              in: "spline",
					                              out: "area"
					                          }
					                      },
					                    color: {
											  		';
									if( $name['plugin_name'] == 'CHECK_SNMP_PRINTER' ||  $name['plugin_name'] == 'GESA_SNMP_PRINTER')
									{
										echo 'pattern: ["#000000", "#00FFFF", "#FF00FF", "#FFFF00"]';
									}
									else
									{
										echo 'pattern: ["#83bc00", "#ffcb1f", "#da002e", "#575759", "#3263c5", "#a833c4", "#e20e6f", "#0ee29b", "#e2720e", "#e2220e"]';	
									}					                        
					               echo '      },
					                      zoom: {
					                      enabled: true
					                    },
					                    point: {
					                      show: false
					                    },
					                      axis: {
					                          x: {
					                              type: "timeseries",
					                              tick: {';

					                    if($diff->format('%a')==1)
										{
											echo 'format: "%H:%M",';
										}
										else 
										{
											echo 'format: "%d-%m",';
										}
										echo '
											  		 rotate: 75,
					                                  fit:false
					                              },
					                              label: {
					                                position: "outer-center"
					                              }
					                          },
					                          y: {
					                            show: true,
					                            label: {
					                              text: yName,
					                              position:"outer-middle"
					                            },
					                            tick: {
					                              format: function(d){
					                                if( yName == "percent") {
					                                  return d+" %";
					                                }else if( yName == "Celsius") {
					                                  return d+" °";
					                                }else if( yName == "second" || yName == "ms" || yName == "milliseconde" || yName == "MB/s" || yName == "number") {
					                                  return d;
					                                }else{
					                                  
					                                  return convertByte(d);                                
					                                }
					                              }
					                            }
					                          }
					                      }
					
					                    });
					
					            });
					        <!-- {/literal} -->
					      </script>';
					}
				}
			}			
		}
		echo '</tbody></table></div></section>';
}
elseif($action=="update")
{	
	$template_path = $path.'/plugin/report/templates';
	$param = json_decode($query['include_parameter'],true);

	$rightWriting=$_GET['writingright'];	
	if(!isset($rightWriting))
	{
		$rightWriting=$_POST['writingright'];
	}
	$smarty->assign('rightWriting',$rightWriting);
	
	$smarty->assign('block',$query);
	$smarty->assign('param',$param);
	$taille = explode("px", $param['title']['style']['font-size']);
	$smarty->assign('TaillePoliceTitle',$taille[0]);
	$taille = explode("px", $param['description']['style']['font-size']);
	$smarty->assign('TaillePoliceDescr',$taille[0]);
	$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
	$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	$smarty->assign('forme',$param['forme']);
	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			// Param Title
			$param['title']['text']=$_POST["blockname"];
			$TaillePoliceTitle = $_POST["namesize"];
			$param['title']['style']['font-size']=$TaillePoliceTitle."px";
			$param['title']['style']['text-align']=$_POST["nameposition"];
			$param['title']['style']['color']=$_POST["blockcolor"];
			
			// Param Descr
			$param['description']['text']=$_POST["blockdescription"];
			$TaillePoliceDescr=$_POST["blocksize"];
			$param['description']['style']['font-size']=$TaillePoliceDescr."px";
			$param['description']['style']['text-align']=$_POST["desciptionposition"];
		
			// Service
			$param['nodeid']=$_POST['nodes'];
			$param['serviceid']=$_POST['services'];
			
			// Frome
			$param['forme']=$_POST['forme'];
			$param['affiche_technical_name']=$_POST['technical_name'];
		
			$paramSave = json_encode($param);
		
			$query=Model_Report::getReportIncludeBlock($dbconnection,$_POST['blockid']);
			$query= $query[0];

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		
		$smarty->assign('block',$query);
		$smarty->assign('param',$param);
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('TaillePoliceTitle',$taille[0]);
		$taille = explode("px", $param['description']['style']['font-size']);
		$smarty->assign('TaillePoliceDescr',$taille[0]);
		$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
		$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
		$smarty->assign('forme',$param['forme']);
	}
		
	$listnode = array();
	//Récupération des services
	if(!empty($param['serviceid']))
	{
		$services = Model_esia::getServices($dbconnection,null,$param['serviceid']);		
		foreach($services as $ser)
		{
			if(!in_array($ser['device_id'],$listnode))
				$listnode[]=$ser['device_id'];
		}
		foreach($services as $ser)
		{
			$listservice[]=$ser['id'];
		}
	}

	$smarty->assign('serviceid',$listservice);
	
	$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
	$list=array();

	foreach($nodes as $node)
	{
		$selected='no';
		if(in_array($node->getId(),$listnode))
		{
			$selected='yes';
		}
		$list[]=array('id'=>$node->getId(),
				'name'=>$node->getGroup().'>'.$node->getName(),
				'selected'=>$selected
					
		);
	}
	$smarty->assign('adm_list_node', $list);
	$smarty->assign('action','update');
	$smarty->display($template_path.'/graphique.html');
}
elseif($action =="getservice")
{
	$template_path = $path.'/plugin/report/templates';
	if(isset($_GET['nodeid']))
	{
		$tablenodeid = json_decode($_GET['nodeid']);
		$list=array();
		foreach($tablenodeid as $nodeid)
		{
			$node = Model_esia::InstanceNode($dbconnection, $nodeid);
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				foreach ($services as $service)
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
					$list[$service['id']]=$node->getName().' > '.$common_name;
				}
			}
		}
		echo json_encode($list);
		exit(0);
	}
}

/**
 @brief retourne le code d'erreur
 @detail retourne le code d'erreur en fonction des seuils de critique et de warning
 @params integer $idser contient l'identifiant d'un service
 @params array $array liste des services
 @retval	false | array $ret contenant
 @throw void
 */

function SearchIfContainService($array, $idser) 
{
	$ret=array();
	foreach ($array as $Element => $tab_elem)
	{
		if ($tab_elem['id'] == $idser) 
		{
			$ret['plugin_name']=$tab_elem['check_plugin_name'];
			$ret['service_name']=$tab_elem['name'];
			$ret['device_name']=$tab_elem['device_name'];
			return $ret;
		}
	}
	return false;
}

/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}

?>
